marmix/simulations/urls.py
# -*- coding: UTF-8 -*-
# urls.py
#
# Copyright (C) 2014 HES-SO//HEG Arc
#
# Author(s): Cédric Gaspoz <cedric.gaspoz@he-arc.ch>
#
# This file is part of MarMix.
#
# MarMix is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MarMix is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MarMix. If not, see <http://www.gnu.org/licenses/>.

# Stdlib imports

# Core Django imports
from django.conf.urls import patterns, url

# Third-party app imports

# MarMix imports
from .views import SimulationDetailView, SimulationListView, TeamsSelectionView, SimulationCreate, SimulationUpdate, \
    SimulationDelete, TeamJoinView, TeamDetailView, teams_export_xlsx, SimulationInitializeView, manage_simulation, \
    MarketView, SimulationInfoUpdate, company_shares_export_xlsx

urlpatterns = patterns('',
    url(r'^(?P<pk>\d+)/select-teams/$', TeamsSelectionView.as_view(), name='teams-selection-view'),
    url(r'^(?P<pk>\d+)/$', SimulationDetailView.as_view(), name='simulations-detail-view'),
    url(r'^add/(?P<customer_id>\d+)/$', SimulationCreate.as_view(), name='simulation-add-view'),
    url(r'^(?P<pk>\d+)/update/info/$', SimulationInfoUpdate.as_view(), name='simulation-info-update-view'),
    url(r'^(?P<pk>\d+)/update/$', SimulationUpdate.as_view(), name='simulation-update-view'),
    url(r'^(?P<pk>\d+)/delete/$', SimulationDelete.as_view(), name='simulation-delete-view'),
    url(r'^(?P<pk>\d+)/initialize/$', SimulationInitializeView.as_view(), name='simulation-initialize-view'),
    url(r'^(?P<simulation_id>\d+)/state/(?P<next_state>\d+)/$', manage_simulation, name='simulation-manage-state'),
    url(r'^join-team/$', TeamJoinView.as_view(), name='team-join-view'),
    url(r'^team/(?P<pk>\d+)/$', TeamDetailView.as_view(), name='team-detail-view'),
    url(r'^(?P<simulation_id>\d+)/teams/export/$', teams_export_xlsx, name='teams-export-xlsx-simulation'),
    url(r'^(?P<simulation_id>\d+)/company-shares/export/$', company_shares_export_xlsx, name='company-shares-export-xlsx-simulation'),
    url(r'^teams/export/(?P<customer_id>\d+)/$', teams_export_xlsx, name='teams-export-xlsx-customer'),
    url(r'^teams/export/$', teams_export_xlsx, name='teams-export-xlsx'),
    url(r'market/$', MarketView.as_view(), name='market-view'),
    url(r'^', SimulationListView.as_view(), name='simulations-list-view'),
)

marmix/urls.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static
from django.views.generic import TemplateView

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()
import permission
permission.autodiscover()
from simulations.views import RankingView
from django.contrib.flatpages.sitemaps import FlatPageSitemap
from django.contrib.sitemaps.views import sitemap
from sitemaps import StaticViewSitemap

sitemaps = {
    'flatpages': FlatPageSitemap,
    'static': StaticViewSitemap,
}

urlpatterns = patterns('',
    url(r'^$',  # noqa
        TemplateView.as_view(template_name='pages/home.html'),
        name="home"),
    url(r'^contact/', include('envelope.urls')),
    # Uncomment the next line to enable the admin:
    url(r'^admin/', include(admin.site.urls)),

    # User management
    url(r'^users/', include("users.urls", namespace="users")),
    url(r'^accounts/', include('allauth.urls')),

    # Uncomment the next line to enable avatars
    url(r'^avatar/', include('avatar.urls')),

    # MarMix apps urls
    url(r'^stocks/', include('stocks.urls')),
    url(r'^customers/', include('customers.urls')),
    url(r'^simulations/', include('simulations.urls')),
    url(r'^tickers/', include('tickers.urls')),
    url(r'^ranking/(?P<pk>\d+)/', RankingView.as_view(), name='ranking-view'),
    url(r'^pages/', include('django.contrib.flatpages.urls')),
    url(r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'),
    url(r'^robots\.txt', include('robots.urls')),

) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += patterns('django.contrib.flatpages.views',
    url(r'^about/$', 'flatpage', {'url': '/about/'}, name='about'),
    url(r'^help/$', 'flatpage', {'url': '/help/'}, name='help'),
    url(r'^sitemap/$', 'flatpage', {'url': '/sitemap/'}, name='sitemap'),
    url(r'^start/$', 'flatpage', {'url': '/start/'}, name='start'),
)

from django.conf.urls import url, include
from simulations.views import SimulationViewSet, CurrencyViewSet, TeamViewSet, ClockViewSet
from stocks.views import StockViewSet, QuoteViewSet, OrderViewSet, HoldingsViewSet, CreateOrderViewSet, DividendsViewSet, MarketViewSet, OrderBookViewSet
from users.views import UserViewSet, LoginView, current_user
from tickers.views import CompaniesViewSet
from rest_framework.routers import DefaultRouter


# Create a router and register our viewsets with it.
router = DefaultRouter()
router.register(r'simulations', SimulationViewSet)
router.register(r'currencies', CurrencyViewSet)
router.register(r'users', UserViewSet)
router.register(r'stocks', StockViewSet, base_name='stock')
router.register(r'quotes', QuoteViewSet)
router.register(r'teams', TeamViewSet)
router.register(r'orders', OrderViewSet, base_name='order')
router.register(r'order', CreateOrderViewSet, base_name='create-order')
router.register(r'holdings', HoldingsViewSet, base_name='holdings')
router.register(r'clock', ClockViewSet, base_name='clock')
router.register(r'tickers', CompaniesViewSet, base_name='ticker')
router.register(r'dividends', DividendsViewSet, base_name='dividend')
router.register(r'market', MarketViewSet, base_name='market')
router.register(r'book', OrderBookViewSet, base_name='book')

# The API URLs are now determined automatically by the router.
# Additionally, we include the login URLs for the browsable API.
urlpatterns += [
    url(r'^api/v1/', include(router.urls)),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    url(r'^api/v1/auth/login/$', LoginView.as_view(), name='login'),
    url(r'^api/v1/current-user/$', current_user, name='current_user'),
]

marmix/users/urls.py
# -*- coding: utf-8 -*-
from django.conf.urls import patterns, url

from users import views
from simulations.views import TeamJoinView

urlpatterns = patterns('',
    # URL pattern for the UserListView  # noqa
    url(
        regex=r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),
    # URL pattern for the UserRedirectView
    url(
        regex=r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),
    # URL pattern for the UserDetailView
    url(
        regex=r'^(?P<username>[\w.@+-]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),
    # URL pattern for the UserUpdateView
    url(
        regex=r'^~update/$',
        view=views.UserUpdateView.as_view(),
        name='update'
    ),
)

marmix/stocks/models.py
# -*- coding: UTF-8 -*-
# models.py
#
# Copyright (C) 2014 HES-SO//HEG Arc
#
# Author(s): Cédric Gaspoz <cedric.gaspoz@he-arc.ch>
#
# This file is part of MarMix.
#
# MarMix is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MarMix is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MarMix. If not, see <http://www.gnu.org/licenses/>.

# Stdlib imports
from decimal import Decimal, getcontext

# Core Django imports
from django.db import models, transaction
from django.utils.translation import ugettext_lazy as _
from django.db import connection

# Third-party app imports
from django_extensions.db.models import TimeStampedModel
import django_filters

# MarMix imports
from simulations.models import Simulation, Team, current_sim_day, stock_historical_prices, current_cash, current_shares
from .tasks import check_matching_orders, set_stock_quote, set_opening_price


def dictfetchall(cursor):
    """
    Returns all rows from a cursor as a dict

    :param cursor:
    :return:
    """
    desc = cursor.description
    return [
        dict(zip([col[0] for col in desc], row))
        for row in cursor.fetchall()
    ]


def simulation_quotes_history(simulation_id):
    cursor = connection.cursor()
    cursor.execute('SELECT * '
                   'FROM quotes_history '
                   'WHERE simulation_id=%s', [simulation_id, ])
    quotes_history = dictfetchall(cursor)
    return quotes_history


class Stock(TimeStampedModel):
    """
    Stocks are shares of a company that are automatically generated during the simulation setup.
    """
    simulation = models.ForeignKey(Simulation, verbose_name=_("simulation"), related_name="stocks", help_text=_("Related simulation"))
    symbol = models.CharField(verbose_name=_("symbol"), max_length=4, help_text=_("Symbol of the stock (4 chars)"))
    name = models.CharField(verbose_name=_("name"), max_length=100, help_text=_("Full name of the stock"))
    description = models.TextField(verbose_name=_("description"), blank=True, help_text=_("Description of the stock (HTML)"))
    quantity = models.IntegerField(verbose_name=_("quantity"), default=1, help_text=_("Total quantity of stocks in circulation"))
    price = models.DecimalField(verbose_name=_("stock price"), max_digits=24, decimal_places=4,
                                default='0.0000', help_text=_("Current stock price"))
    opening_price = models.DecimalField(verbose_name=_("opening price"), max_digits=24, decimal_places=4,
                                        null=True, blank=True, help_text=_("Opening price"))

    class Meta:
        verbose_name = _('stock')
        verbose_name_plural = _('stocks')
        ordering = ['symbol']

    def _last_quote(self):
        try:
            last_quote = self.quotes.all()[0]
        except IndexError:
            last_quote = None
        return last_quote
    last_quote = property(_last_quote)

    def _historical_prices(self):
        return stock_historical_prices(self.id)
    historical_prices = property(_historical_prices)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        if self.price != 0 and not self.opening_price:
            print("Preparing opening: STOCK %s @ %s" % (self.symbol, self.price))
            # It's an update and we have the first quotation for this stock
            self.opening_price = self.price
            models.Model.save(self, force_insert, force_update, using, update_fields)
            set_opening_price.apply_async([self.id, self.price])
        else:
            models.Model.save(self, force_insert, force_update, using, update_fields)

    def __str__(self):
        return self.symbol


class Quote(models.Model):
    """
    Quotes are the price of a given stock at a certain time.
    """
    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="quotes", help_text=_("Related stock"))
    price = models.DecimalField(verbose_name=_("stock price"), max_digits=24, decimal_places=4,
                                default='0.0000', help_text=_("Current stock price"))
    timestamp = models.DateTimeField(verbose_name=_("timestamp"), auto_now_add=True, help_text=_("Timestamp of the quote"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))

    class Meta:
        verbose_name = _('quote')
        verbose_name_plural = _('quotes')
        ordering = ['-timestamp']

    def __str__(self):
        return "%s@%s R%sD%s (%s)" % (self.stock, self.price, self.sim_round, self.sim_day, self.timestamp)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        current = current_sim_day(self.stock.simulation_id)
        self.sim_round = current['sim_round']
        self.sim_day = current['sim_day']
        models.Model.save(self, force_insert, force_update, using, update_fields)


class HistoricalPrice(models.Model):
    """
    A summary of the quotes, updated each sim_day.
    """
    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="history", help_text=_("Related stock"))
    price_open = models.DecimalField(verbose_name=_("open"), max_digits=24, decimal_places=4,
                                     default='0.0000', help_text=_("Current stock price"))
    price_high = models.DecimalField(verbose_name=_("high"), max_digits=24, decimal_places=4,
                                     default='0.0000', help_text=_("Current stock price"))
    price_low = models.DecimalField(verbose_name=_("low"), max_digits=24, decimal_places=4,
                                    default='0.0000', help_text=_("Current stock price"))
    price_close = models.DecimalField(verbose_name=_("close"), max_digits=24, decimal_places=4,
                                      default='0.0000', help_text=_("Current stock price"))
    volume = models.IntegerField(verbose_name=_("volume"), help_text=_("Day volume"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))
    timestamp = models.DateTimeField(verbose_name=_("timestamp"), auto_now_add=True, help_text=_("Timestamp of the historical price"))

    class Meta:
        verbose_name = _('historical price')
        verbose_name_plural = _('historical prices')
        ordering = ['-sim_round', '-sim_day']

    def __str__(self):
        return "%s R%sD%s O:%s | H:%s | L:%s | C:%s | V:%s" % (self.stock, self.sim_round, self.sim_day, self.price_open, self.price_high, self.price_low, self.price_close, self.volume)

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        self.sim_round = current_sim_day(self.stock.simulation_id)['sim_round']
        self.sim_day = current_sim_day(self.stock.simulation_id)['sim_day']
        models.Model.save(self, force_insert, force_update, using, update_fields)


class Order(models.Model):
    """
    Orders are made by teams and posted in the order book. They are then processed by the order manager.
    BID is the highest price that a buyer is willing to pay for a stock.
    ASK is the lowest price that a seller is willing to accept for a stock.
    """
    BID = 'BID'
    ASK = 'ASK'
    ORDER_TYPE_CHOICES = (
        (BID, _('bid')),
        (ASK, _('ask')),
    )

    SUBMITTED = 'SUBMITTED'
    PROCESSED = 'PROCESSED'
    FAILED = 'FAILED'
    ORDER_STATE_CHOICES = (
        (SUBMITTED, _('submitted')),
        (PROCESSED, _('processed')),
        (FAILED, _('failed')),
    )

    stock = models.ForeignKey('Stock', verbose_name=_("stock"), related_name="orders", help_text=_("Related stock"))
    team = models.ForeignKey(Team, verbose_name=_("team"), related_name="orders", help_text=_("Team which placed the order"))
    order_type = models.CharField(verbose_name=_("type of order"), max_length=5, choices=ORDER_TYPE_CHOICES,
                                  default=BID, help_text=_("The type of order (bid/ask)"))
    quantity = models.IntegerField(verbose_name=_("quantity ordered"), default=0, help_text=_("Quantity ordered. If the total quantity can not be provided, a new order will be created with the balance"))
    price = models.DecimalField(verbose_name=_("price tag"), max_digits=24, decimal_places=4,
                                blank=True, null=True, help_text=_("Price tag for one stock. If NULL, best available price"))
    created_at = models.DateTimeField(verbose_name=_("created"), auto_now_add=True, help_text=_("Creation of the order"))
    transaction = models.ForeignKey('Transaction', verbose_name=_("transaction"), related_name="orders", null=True,
                                    blank=True, help_text=_("Related transaction"))
    state = models.CharField(verbose_name=_("state of the order"), max_length=25, choices=ORDER_STATE_CHOICES,
                             default=SUBMITTED, help_text=_("The state of the order (submitted/processed/failed)"))
    sim_round = models.IntegerField(verbose_name=_("round"), default=0, help_text=_("Current round"))
    sim_day = models.IntegerField(verbose_name=_("day"), default=0, help_text=_("Current day"))
    timestamp = models.DateTimeField(verbose_name=_("updated"), auto_now=True, help_text=_("Last update of the order"))

    class Meta:
        verbose_name = _('order')
        verbose_name_plural = _('orders')

marmix/templates/simulations/join_team_form.html
{%  extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}
    Join a Team
{% endblock title %}

{% block content %}
<section class="page-top">
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <ul class="breadcrumb">
                    <li><a href="{% url 'home' %}">Home</a></li>
                    <li class="active">Dashboard</li>
                </ul>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <h1>Join a Team</h1>
            </div>
        </div>
    </div>
</section>
<div class="container">
    <p>In order to join a new team, enter the provided UUID in the filed below.</p>
    <form action="{% url 'team-join-view' %}" method="post">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success"><i class="fa fa-check-square-o"></i> Join team</button>
    </form>
</div>
{% endblock content %}

marmix/templates/simulations/manage_teams_form.html
{%  extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}
    Simulation - Manage teams
{% endblock title %}

{% block content %}
<div role="main" class="main">
    <section class="full">
    </section>
    <div class="container">
        <h1>Manage teams</h1>
        <div class="row">
            <div class="col-md-12">
                <form action="{% url 'teams-selection-view' simulation_id %}" method="post">
                    {% csrf_token %}
                    {{ form|crispy }}
                    <button type="submit" class="btn btn-success"><i class="fa fa-check-square-o"></i> Update participating teams</button>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

marmix/templates/simulations/market.html
{%  extends "base.html" %}

{% block title %}
    Simulation detail
{% endblock title %}

{% block content %}
<div role="main" class="main">
    <section class="full">
    </section>
    <div class="container">
        <h1>Market {{ simulation.code }}</h1>
        <div class="row">
            <div class="col-md-12">
                {% include "simulations/includes/clock.html" with clock=simulation.get_sim_day %}

                <h2>Ranking</h2>

                {% include "simulations/includes/ranking_table.html" with teams=simulation.get_rank_list %}

                <h2>Stocks</h2>

                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th>Symbol</th>
                            <th>Current</th>
                            <th>Day min</th>
                            <th>Day max</th>
                            <th>Lifetime min</th>
                            <th>Lifetime max</th>
                        </tr>
                    </thead>
                    <tbody>
                    {% for stock in simulation.get_stocks_list %}
                        <tr>
                            <td>{{ stock.symbol }}</td>
                            <td>{{ stock.price|stringformat:".2f" }}</td>
                            <td>{{ stock.min_day|stringformat:".2f" }}</td>
                            <td>{{ stock.max_day|stringformat:".2f" }}</td>
                            <td>{{ stock.min_life|stringformat:".2f" }}</td>
                            <td>{{ stock.max_life|stringformat:".2f" }}</td>
                        </tr>
                        {% empty %}
                        <tr>
                            <td colspan="3">No team available for this market!</td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

marmix/templates/simulations/simulation_confirm_delete.html
{%  extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}
    Delete the simulation
{% endblock title %}

{% block content %}
<div role="main" class="main">
    <section class="full">
    </section>
    <div class="container">
        <h1>Delete simulation {{ object.code }}</h1>
        <div class="row">
            <div class="col-md-12">
                <form action="{% url 'simulation-delete-view' object.id %}" method="post">{% csrf_token %}
                    <p>Are you sure that you want to delete the following simulation?</p>
                    <dl class="dl-horizontal">
                    <dt>Simulation code</dt>
                    <dd>{{ object.code }}</dd>
                    <dt>Administrator</dt>
                    <dd><a href="{% url 'users:detail' object.user.username  %}">{{ object.user }}</a></dd>
                    <dt>Simulation type</dt>
                    <dd>{{ object.get_simulation_type_display }}</dd>
                    <dt>Number of teams</dt>
                    <dd>{{ object.nb_teams }}</dd>
                    <dt>Initial capital</dt>
                    <dd>{{ object.capital|stringformat:".2f" }}</dd>
                    <dt>Currency</dt>
                    <dd>{{ object.currency }}</dd>
                    <dt>Current state</dt>
                    <dd>{{ object.get_state_display }}</dd>
                    <dt>Created at</dt>
                    <dd>{{ object.created }}</dd>
                    </dl>
                    <button type="submit" class="btn btn-danger"><i class="fa fa-trash-o"></i> Delete this simulation</button>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

marmix/templates/simulations/simulation_detail.html
{%  extends "base.html" %}

{% block title %}
    Customer detail
{% endblock title %}

{% block content %}
<div role="main" class="main">
    <section class="full">
    </section>
    <div class="container">
        <h1>{{ object.customer }}</h1>
        <div class="row">
            <div class="col-md-4">
                <dl class="dl-horizontal">
                    <dt>Simulation code</dt>
                    <dd>{{ object.code }}</dd>
                    <dt>Administrator</dt>
                    <dd><a href="{% url 'users:detail' object.user.username  %}">{{ object.user }}</a></dd>
                    <dt>Simulation type</dt>
                    <dd>{{ object.get_simulation_type_display }}</dd>
                    <dt>Number of teams</dt>
                    <dd>{{ object.nb_teams }}</dd>
                    <dt>Initial capital</dt>
                    <dd>{{ object.capital|stringformat:".2f" }}</dd>
                    <dt>Currency</dt>
                    <dd>{{ object.currency }}</dd>
                    <dt>Current state</dt>
                    <dd>{{ object.get_state_display }}</dd>
                    <dt>Created at</dt>
                    <dd>{{ object.created }}</dd>
                </dl>
            </div>
            <div class="col-md-4">
                <ul class="list-group">
                {% if object.state < simulation_state.READY %}
                    <li class="list-group-item"><a class="btn btn-primary" href="{% url 'simulation-update-view' object.id %}"><i class="fa fa-pencil-square-o"></i> Edit the simulation</a></li>
                {% endif %}
                {% if object.state < simulation_state.READY %}
                    <li class="list-group-item"><a class="btn btn-warning btn-block" href="{% url 'simulation-initialize-view' object.id %}"><i class="fa fa-cogs"></i> Initialize the simulation</a></li>
                {% elif object.state == simulation_state.READY or object.state == simulation_state.PAUSED %}
                    <li class="list-group-item"><a class="btn btn-success btn-block" href="{% url 'simulation-manage-state' object.id simulation_state.RUNNING %}"><i class="fa fa-play"></i> Start the simulation</a></li>
                {% elif object.state == simulation_state.RUNNING %}
                    <li class="list-group-item"><a class="btn btn-warning btn-block" href="{% url 'simulation-manage-state' object.id simulation_state.PAUSED %}"><i class="fa fa-pause"></i> Pause the simulation</a></li>
                {% elif object.state == simulation_state.FINISHED %}
                    <li class="list-group-item"><a class="btn btn-danger btn-block" href="{% url 'simulation-manage-state' object.id simulation_state.ARCHIVED %}"><i class="fa fa-eject"></i> Archive the simulation</a></li>
                {% endif %}
                    <li class="list-group-item"><a class="btn btn-info btn-block" href="https://m3.marmix.ch/static/dashboard/#/clock" target="_blank"><i class="fa fa-clock-o "></i> Simulation clock</a></li>
                    <li class="list-group-item"><a class="btn btn-primary btn-block" href="{% url 'companies-shares-create-view' object.id object.get_sim_day.sim_round %}"><i class="fa fa-money"></i> Pay dividends</a></li>
                    <li class="list-group-item"><a class="btn btn-warning btn-block" href="{% url 'closes-market-view' object.id %}"><i class="fa fa-btc"></i> Set closing prices</a></li>
                </ul>
            </div>
            <div class="col-md-4">
                <div class="panel panel-primary">
                    <div class="panel-heading">
                        <div class="btn-group pull-right">
                            <a class="btn btn-warning btn-xs" href="{% url 'simulation-info-update-view' object.id %}"><i class="fa fa-pencil-square"></i> Edit info box</a>
                        </div>
                        <h3 class="panel-title"><i class="fa fa-comments-o"></i> Simulation Infobox</h3>
                    </div>
                    <div class="panel-body">
                        {{ object.info|safe }}
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
                {% include "simulations/includes/clock.html" with clock=object.get_sim_day %}

                <h2>Teams</h2>

                <a class="btn btn-primary" href="{% url 'teams-selection-view' object.id %}"><i class="fa fa-plus-square-o fa-lg"></i> Manage teams for this simulation</a>
                <a class="btn btn-info" href="{% url 'teams-export-xlsx-simulation' object.id %}"><i class="fa fa-file-excel-o fa-lg"></i> Export teams</a>

                {% include "simulations/includes/teams_table.html" with teams=teams %}

                <h2>Stocks</h2>

                {% include "stocks/includes/stocks_table.html" with stocks=object.stocks.all %}
            </div>
        </div>
    </div>
</div>
{% endblock content %}

marmix/templates/simulations/team_detail.html
{%  extends "base.html" %}

{% block title %}
    Team detail
{% endblock title %}

{% block content %}
<div role="main" class="main">
    <section class="full">
    </section>
    <div class="container">
        <h1>Team {{ object.name }}</h1>
        <div class="row">
            <div class="col-md-12">
                <dl class="dl-horizontal">
                    <dt>Simulation(s)</dt>
                    <dd>
                        {% if object.simulations.all %}
                            {% for simulation in object.simulations.all %}
                                {{ simulation }}
                            {% if not forloop.last %}/ {% endif %}
                            {% endfor %}
                        {% else %}
                            Not part of a simulation
                        {% endif %}
                    </dd>
                    <dt>Users</dt>
                    <dd>
                        {% if object.users.all %}
                            {% for user in object.users.all %}
                                <a href="{% url 'users:detail' user.username  %}">{{ user }}</a>
                            {% if not forloop.last %}/ {% endif %}
                            {% endfor %}
                        {% else %}
                            No user with administrative rights!
                        {% endif %}
                    </dd>
                    <dt>Registration code</dt>
                    <dd>{{ object.uuid }}</dd>
                </dl>
            </div>
        </div>
    </div>
</div>
{% endblock content %}